package org.appconn;

import org.appconn.annotation.AppconnField;
import org.appconn.annotation.AppconnMethod;
import org.appconn.annotation.AppconnService;
import org.appconn.annotation.AppconnType;
import org.appconn.channel.*;
import org.appconn.mgmt.Client;

import java.lang.reflect.*;
import java.lang.reflect.Type;
import java.util.*;
import java.util.function.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * <i>appconn</i> coders.
 */
interface Coders {

    String CODERS_VERSION = "1.2";

    char DOT = '.';
    char HYPHEN = '-';
    char UNDERSCORE = '_';

    String INDENT_4 = "    ";
    String INDENT_8 = INDENT_4 + INDENT_4;
    String INDENT_12 = INDENT_8 + INDENT_4;

    String L_S = System.getProperty("line.separator");
    String CLASS_COMMENT = "/**" + L_S + " * Class generated by <i>appconn</i> Coders." + L_S + " * Coders version: " + CODERS_VERSION + L_S + " */" + L_S;

    UnaryOperator<String> CAPITALIZE = s -> s.length() > 0 ? s.substring(0, 1).toUpperCase().concat(s.substring(1)) : s;

    UnaryOperator<String> DECAPITALIZE = s -> s.length() > 0 ? s.substring(0, 1).toLowerCase().concat(s.substring(1)) : s;

    Predicate<Field> IS_APPCONN_FIELD = f -> f.getAnnotation(AppconnField.class) != null;

    Function<Class<?>, AppconnService> APPCONN_SERVICE_ANNOTATION = t -> t.getAnnotation(AppconnService.class);

    Function<Method, AppconnMethod> APPCONN_METHOD_ANNOTATION = m -> m.getAnnotation(AppconnMethod.class);

    Predicate<Class<?>> IS_APPCONN_SERVICE = t -> t.getAnnotation(AppconnService.class) != null && Modifier.isPublic(t.getModifiers());

    Predicate<Method> IS_APPCONN_METHOD = m -> APPCONN_METHOD_ANNOTATION.apply(m) != null;

    Predicate<Class<?>> IS_APPCONN_TYPE = t -> t.getAnnotation(AppconnType.class) != null;

    Predicate<Field> IS_PUBLIC = f -> Modifier.isPublic(f.getModifiers());

    Predicate<Class<?>> IS_ABSTRACT = t -> Modifier.isAbstract(t.getModifiers());

    Predicate<Class<?>> IS_COLLECTION = t -> t.equals(Collection.class);

    Function<Type, Optional<Class<?>>> PARAMETERIZED_TYPE = t -> {
        if (t instanceof ParameterizedType) {
            ParameterizedType type = (ParameterizedType) t;
            if (type.getActualTypeArguments() != null && type.getActualTypeArguments().length > 0) {
                try {
                    return Optional.of(Class.forName(type.getActualTypeArguments()[0].getTypeName()));
                } catch (ClassNotFoundException e) {
                    return Optional.empty();
                }
            } else return Optional.empty();
        } else return Optional.empty();
    };

    Predicate<Class<?>> HAS_DEFAULT_CONSTRUCTOR = t -> {
        try {
            t.getConstructor();
            return true;
        } catch (NoSuchMethodException e) {
            return false;
        }
    };

    Predicate<Class<?>> HAS_STRING_CONSTRUCTOR = t -> {
        try {
            t.getConstructor(String.class);
            return true;
        } catch (NoSuchMethodException e) {
            return false;
        }
    };

    BiPredicate<Class<?>, List<Field>> HAS_APPCONN_CONSTRUCTOR = (t, fields) -> {
        Class<?>[] parameterTypes = new Class[fields.size()];
        for (int i = 0; i < fields.size(); i++) parameterTypes[i] = fields.get(i).getType();
        try {
            t.getConstructor(parameterTypes);
            return true;
        } catch (NoSuchMethodException e) {
            return false;
        }
    };

    String GET = "get";
    Function<Field, String> GETTER_NAME = f -> GET.concat(CAPITALIZE.apply(f.getName()));

    BiPredicate<Class<?>, Field> HAS_GETTER = (t, f) -> {
        try {
            t.getMethod(GETTER_NAME.apply(f));
            return true;
        } catch (NoSuchMethodException e) {
            return false;
        }
    };

    String SET = "set";
    Function<Field, String> SETTER_NAME = f -> SET.concat(CAPITALIZE.apply(f.getName()));

    BiPredicate<Class<?>, Field> HAS_SETTER = (t, f) -> {
        try {
            t.getMethod(SETTER_NAME.apply(f), f.getType());
            return true;
        } catch (NoSuchMethodException e) {
            return false;
        }
    };

    static Class<?> topologicalType(Class<?> type, Type parameterizedType) throws CoderException {
        return type.isArray() ? type.getComponentType()
                              : Coders.IS_COLLECTION.test(type) ? Coders.PARAMETERIZED_TYPE.apply(parameterizedType)
                                                                                           .orElseThrow(() -> new CoderException(type + " has unknown type"))
                                                                : type;
    }

    static List<Field> appconnFields(Class<?> type) {
        List<Field> fields = new ArrayList<>();
        if (IS_APPCONN_TYPE.test(type)) {
            for (Class<?> tmpClass = type; !tmpClass.equals(Object.class); tmpClass = tmpClass.getSuperclass()) {
                fields.addAll(Stream.of(tmpClass.getDeclaredFields())
                                    .filter(IS_APPCONN_FIELD)
                                    .collect(Collectors.toList()));
            }
        }
        return fields;
    }

    Function<Class<?>, String> TYPE_READER_NAME = t -> t.getName().toUpperCase().replace(DOT, UNDERSCORE) + "_READER";

    Function<Class<?>, String> GET_ARRAY_CODE = t -> (t.isPrimitive() ? Types.ARRAY_READERS.get(t) + ".get(r"
                                                                      : Types.GET_TYPES + "(r, " + t.getName() + ".class, " + (IS_APPCONN_TYPE.test(t) ? TYPE_READER_NAME.apply(t)
                                                                                                                                                       : Types.READERS.get(t))) + ")";

    Function<Class<?>, String> GET_COLLECTION_CODE = t -> Types.GET_COLLECTION + "(r, " + t.getName() + ".class, " + (IS_APPCONN_TYPE.test(t) ? TYPE_READER_NAME.apply(t)
                                                                                                                                              : Types.READERS.get(t)) + ")";

    static String getType(Class<?> type, Type parameterizedType) throws CoderException {
        return type.isPrimitive() ? "r." + Types.GET_METHOD.get(type) + "()"
                                  : type.isArray() ? GET_ARRAY_CODE.apply(type.getComponentType())
                                                   : IS_COLLECTION.test(type) ? GET_COLLECTION_CODE.apply(PARAMETERIZED_TYPE.apply(parameterizedType)
                                                                                                                            .orElseThrow(() -> new CoderException(parameterizedType + " has unknown type")))
                                                                              : (IS_APPCONN_TYPE.test(type) ? TYPE_READER_NAME.apply(type)
                                                                                                            : Types.READERS.get(type)) + ".get(r)";
    }

    static String setFieldCode(Field field) throws CoderException {
        return IS_PUBLIC.test(field) ? field.getName() + " = " + getType(field.getType(), field.getGenericType())
                                     : SETTER_NAME.apply(field) + "(" + getType(field.getType(), field.getGenericType()) + ")";
    }

    static String typeReaderCode(Class<?> type, List<Field> fields) throws CoderException {
        String code = INDENT_4 + "private static final " + TypeReader.class.getSimpleName() + "<" + type.getName() + "> " + TYPE_READER_NAME.apply(type) +
                      " = readBuffer -> " + Types.GET_TYPE + "(readBuffer, r -> ";
        if (HAS_APPCONN_CONSTRUCTOR.test(type, fields)) {
            code += "new " + type.getName() + "(";
            StringJoiner joiner = new StringJoiner(", ");
            for (Field f : fields) joiner.add(getType(f.getType(), f.getGenericType()));
            code += joiner.toString() + ")";
        } else if (HAS_DEFAULT_CONSTRUCTOR.test(type)) {
            Logger.getLogger("org.appconn").log(Level.WARNING, type.getName() + " using default constructor");

            // setters
            if (!fields.stream().filter(IS_PUBLIC.negate()).allMatch(f -> HAS_SETTER.test(type, f)))
                throw new CoderException(type.getName() + " does not have required setters");

            String instanceName = DECAPITALIZE.apply(type.getSimpleName());
            code += "{" + L_S + INDENT_8 + type.getName() + " " + instanceName + " = new " + type.getName() + "();" + L_S;
            for (Field f : fields) code += INDENT_8 + instanceName + "." + setFieldCode(f) + ";" + L_S;
            code += INDENT_8 + "return " + instanceName + ";" + L_S +
                    INDENT_4 + "}";
        } else throw new CoderException(type.getName() + " does not have default constructor");
        return code + ");" + L_S + L_S;
    }

    Function<Class<?>, String> TYPE_WRITER_NAME = t -> t.getName().toUpperCase().replace(DOT, UNDERSCORE) + "_WRITER";

    BiFunction<Class<?>, String, String> PUT_ARRAY_CODE = (t, u) -> (t.isPrimitive() ? Types.ARRAY_WRITERS.get(t) + ".put(w, " + u
                                                                                     : Types.PUT_TYPES + "(w, " + u + ", " + (IS_APPCONN_TYPE.test(t) ? TYPE_WRITER_NAME.apply(t)
                                                                                                                                                      : Types.WRITERS.get(t))) + ")";

    BiFunction<Class<?>, String, String> PUT_COLLECTION_CODE = (t, u) -> Types.PUT_COLLECTION + "(w, " + u + ", " + (IS_APPCONN_TYPE.test(t) ? TYPE_WRITER_NAME.apply(t)
                                                                                                                                             : Types.WRITERS.get(t)) + ")";

    static String putType(Class<?> type, Type parameterizedType, String value) throws CoderException {
        return type.isPrimitive() ? "w." + Types.PUT_METHOD.get(type) + "(" + value + ")"
                                  : type.isArray() ? PUT_ARRAY_CODE.apply(type.getComponentType(), value)
                                                   : IS_COLLECTION.test(type) ? PUT_COLLECTION_CODE.apply(PARAMETERIZED_TYPE.apply(parameterizedType)
                                                                                                                            .orElseThrow(() -> new CoderException(parameterizedType + " has unknown type")), value)
                                                                              : (IS_APPCONN_TYPE.test(type) ? TYPE_WRITER_NAME.apply(type)
                                                                                                            : Types.WRITERS.get(type)) + ".put(w, " + value + ")";
    }

    Function<Field, String> GET_FIELD_VALUE_CODE = f -> "t." + (IS_PUBLIC.test(f) ? f.getName()
                                                                                  : GETTER_NAME.apply(f) + "()");

    static String typeWriterCode(Class<?> type, List<Field> fields) throws CoderException {
        // getters
        if (!fields.stream().filter(IS_PUBLIC.negate()).allMatch(f -> HAS_GETTER.test(type, f)))
            throw new CoderException(type.getName() + " does not have required getters");

        String code = INDENT_4 + "private static final " + TypeWriter.class.getSimpleName() + "<" + type.getName() + "> " + TYPE_WRITER_NAME.apply(type) +
                      " = (writeBuffer, type) -> " + Types.PUT_TYPE + "(writeBuffer, type, (w, t) -> {" + L_S;
        for (Field f : fields)
            code += INDENT_8 + putType(f.getType(), f.getGenericType(), GET_FIELD_VALUE_CODE.apply(f)) + ";" + L_S;
        return code + INDENT_4 + "});" + L_S + L_S;
    }

    static String typesCode(Collection<Class<?>> appconnTypes) throws CoderException {
        StringBuilder code = new StringBuilder();
        for (Class<?> type : appconnTypes) {
            List<Field> fields = appconnFields(type);
            for (Field field : fields) {
                Class<?> t = topologicalType(field.getType(), field.getGenericType());
                if (IS_APPCONN_TYPE.negate().test(t) && !Types.TYPES.contains(t))
                    throw new CoderException(type.getName() + " contains not supported type " + t.getName());
            }
            code.append(typeReaderCode(type, fields));
            code.append(typeWriterCode(type, fields));
        }
        return code.toString();
    }

    Function<Method, Integer> METHOD_KEY = m -> {
        AppconnMethod annotation = APPCONN_METHOD_ANNOTATION.apply(m);
        return annotation.key() > 0 ? annotation.key() : m.toGenericString().hashCode();
    };

    Function<Method, String> STUB_NAME = m -> m.getName() + String.valueOf(METHOD_KEY.apply(m)).replace(HYPHEN, UNDERSCORE);

    Function<Method, String> RUNNABLE_NAME = m -> CAPITALIZE.apply(STUB_NAME.apply(m));

    Predicate<Method> RETURNS_VOID = m -> m.getReturnType().equals(void.class);

    Function<Class<?>, Integer> DELAY_MILLIS = t -> {
        AppconnService annotation = APPCONN_SERVICE_ANNOTATION.apply(t);
        return annotation.delayMillis() > 0 ? annotation.delayMillis() : 0;
    };

    Function<Method, Long> TIMEOUT = m -> {
        AppconnMethod annotation = APPCONN_METHOD_ANNOTATION.apply(m);
        if (annotation.timed())
            return annotation.timeout() > 0 ? annotation.unit().toNanos(annotation.timeout()) : null;
        else return null;
    };

    static String timeoutLiteral(Class<?> service, Method method) throws CoderException {
        Long timeout = TIMEOUT.apply(method);
        if (timeout != null) {
            long tmpTimeout = timeout - DELAY_MILLIS.apply(service) * 1_000_000L;
            if (tmpTimeout > 0) return tmpTimeout + "L";
            else throw new CoderException(method.getName() + " has zero or negative timeout");
        } else return "null";
    }

    static String runnableCode(Class<?> service, Method method) throws CoderException {
        Parameter[] parameters = method.getParameters();
        return INDENT_4 + "private class " + RUNNABLE_NAME.apply(method) + " extends " + MethodRunnable.class.getSimpleName() + " {" + L_S + L_S +
               // fields
               (parameters.length > 0 ? Stream.of(parameters).map(p -> INDENT_8 + "private final " + p.getParameterizedType().getTypeName() + " " + p.getName() + ";" + L_S).collect(Collectors.joining()) + L_S : "") +
               // constructor
               INDENT_8 + "private " + RUNNABLE_NAME.apply(method) + "(" + WriteBuffer.class.getSimpleName() + " writeBuffer, int position" +
               (parameters.length > 0 ? ", " + Stream.of(parameters).map(p -> p.getParameterizedType().getTypeName() + " " + p.getName()).collect(Collectors.joining(", ")) + ") {" + L_S
                                      : ") {" + L_S) +
               INDENT_12 + "super(writeBuffer, position, " + timeoutLiteral(service, method) + ");" + L_S +
               Stream.of(parameters).map(p -> INDENT_12 + "this." + p.getName() + " = " + p.getName() + ";" + L_S).collect(Collectors.joining()) +
               INDENT_8 + "}" + L_S + L_S +
               // execute
               INDENT_8 + "@Override" + L_S + INDENT_8 + "protected void execute() throws Exception {" + L_S +
               INDENT_12 + (RETURNS_VOID.negate().test(method) ? method.getGenericReturnType().getTypeName() + " ret = " : "") +
               "impl." + method.getName() + Stream.of(parameters).map(Parameter::getName).collect(Collectors.joining(", ", "(", ");")) + L_S +
               INDENT_12 + Writer.class.getSimpleName() + ".putReturn(writeBuffer, position, deadline, " +
               (RETURNS_VOID.test(method) ? Writer.class.getSimpleName() + ".VOID"
                                          : "w -> " + putType(method.getReturnType(), method.getGenericReturnType(), "ret")) + ");" + L_S +
               INDENT_8 + "}" + L_S + INDENT_4 + "}" + L_S + L_S;
    }

    static String stubCode(Method method) throws CoderException {
        Parameter[] parameters = method.getParameters();
        String code = INDENT_4 + "public final " + MethodStub.class.getSimpleName() + " " + STUB_NAME.apply(method) + " = (r, w, position) -> new " + RUNNABLE_NAME.apply(method) + "(w, position";
        if (parameters.length > 0) {
            StringJoiner joiner = new StringJoiner(", ");
            for (Parameter p : parameters) joiner.add(getType(p.getType(), p.getParameterizedType()));
            code += ", " + joiner.toString();
        }
        return code + ");" + L_S + L_S;
    }

    static String stubsCode(Class<?> service, Collection<Class<?>> appconnTypes) throws CoderException {
        StringBuilder code = new StringBuilder("package " + service.getPackage().getName() + ";" + L_S + L_S +
                                               "import org.appconn.channel.*;" + L_S + L_S +
                                               CLASS_COMMENT +
                                               "public class " + service.getSimpleName() + "Stubs {" + L_S + L_S +
                                               INDENT_4 + "private final " + service.getSimpleName() + " impl;" + L_S + L_S +
                                               INDENT_4 + "public " + service.getSimpleName() + "Stubs(" + service.getSimpleName() + " impl) {" + L_S +
                                               INDENT_8 + "this.impl = impl;" + L_S +
                                               INDENT_4 + "}" + L_S + L_S);
        code.append(typesCode(appconnTypes));
        for (Method m : service.getMethods()) {
            if (IS_APPCONN_METHOD.test(m)) {
                if (!Stream.of(m.getExceptionTypes()).allMatch(HAS_STRING_CONSTRUCTOR))
                    throw new CoderException(m.getName() + " throws exception without message constructor");
                code.append(runnableCode(service, m));
                code.append(stubCode(m));
            }
        }
        return code.append("}").append(L_S).toString();
    }

    static String typeReader(Class<?> type, Type parameterizedType) throws CoderException {
        return type.isArray() ? "r -> " + GET_ARRAY_CODE.apply(type.getComponentType())
                              : IS_COLLECTION.test(type) ? "r -> " + GET_COLLECTION_CODE.apply(PARAMETERIZED_TYPE.apply(parameterizedType)
                                                                                                                 .orElseThrow(() -> new CoderException(parameterizedType + " has unknown type")))
                                                         : (IS_APPCONN_TYPE.test(type) ? TYPE_READER_NAME.apply(type)
                                                                                       : Types.READERS.get(type));
    }

    Function<Method, String> TIMEOUT_LITERAL = m -> Optional.ofNullable(TIMEOUT.apply(m))
                                                            .map(timeout -> timeout + "L")
                                                            .orElse("null");

    static String methodCallCode(Method method, String indent) throws CoderException {
        Parameter[] parameters = method.getParameters();
        String code = indent + "FutureReturn<" + (method.getReturnType().isPrimitive() ? Types.WRAPPERS.get(method.getReturnType())
                                                                                       : method.getGenericReturnType().getTypeName()) + "> ret = " + AbstractClient.class.getSimpleName() + ".futureReturn(" +
                      typeReader(method.getReturnType(), method.getGenericReturnType()) + ", " + TIMEOUT_LITERAL.apply(method) + ");" + L_S +
                      indent + "Writer.putCall(client.getWriteBuffer(), " + METHOD_KEY.apply(method) + ", client.add(ret), ret, ";
        if (parameters.length == 0) code += Writer.class.getSimpleName() + ".VOID";
        else if (parameters.length == 1)
            code += "w -> " + putType(parameters[0].getType(), parameters[0].getParameterizedType(), parameters[0].getName());
        else {
            code += "w -> {" + L_S;
            for (Parameter p : parameters)
                code += indent + INDENT_4 + putType(p.getType(), p.getParameterizedType(), p.getName()) + ";" + L_S;
            code += indent + "}";
        }
        return code + ");" + L_S + indent + (RETURNS_VOID.negate().test(method) ? "return " : "") + "ret.getReturn();" + L_S;
    }

    Predicate<Method> ADD_STATS = m -> {
        AppconnMethod annotation = APPCONN_METHOD_ANNOTATION.apply(m);
        return annotation.addStats();
    };

    static String methodCode(Method method, boolean extendsServiceClient, Client.CONNS_TYPE connsType, String connectTimeoutLiteral) throws CoderException {
        Parameter[] parameters = method.getParameters();
        Class<?>[] exceptions = method.getExceptionTypes();
        String code = INDENT_4 + "@Override" + L_S + INDENT_4 + "public " + method.getGenericReturnType().getTypeName() + " " + method.getName() + "(" +
                      Stream.of(parameters).map(p -> p.getParameterizedType().getTypeName() + " " + p.getName()).collect(Collectors.joining(", ")) + ")" +
                      (exceptions.length > 0 ? Stream.of(exceptions).map(Class::getName).collect(Collectors.joining(", ", " throws ", "")) : "") + " {" + L_S;
        if (IS_APPCONN_METHOD.test(method)) {
            if (!Stream.of(method.getExceptionTypes()).allMatch(HAS_STRING_CONSTRUCTOR))
                throw new CoderException(method.getName() + " throws exception without message constructor");

            if (extendsServiceClient) {
                if (ADD_STATS.test(method)) code += INDENT_8 + "long nanos = System.nanoTime();" + L_S;
                switch (connsType) {
                    case CONN:
                        code += INDENT_8 + "try {" + L_S +
                                INDENT_12 + "AbstractClient client = getClient(" + METHOD_KEY.apply(method) +
                                (parameters.length > 0 ? ", " + Stream.of(parameters).map(Parameter::getName).collect(Collectors.joining(", ")) : "") + ");" + L_S +
                                methodCallCode(method, INDENT_12);
                        break;
                    case CONNLESS:
                        code += INDENT_8 + "try (AbstractClient client = getClient(" + METHOD_KEY.apply(method) +
                                (parameters.length > 0 ? ", " + Stream.of(parameters).map(Parameter::getName).collect(Collectors.joining(", ")) : "") + ")) {" + L_S +
                                methodCallCode(method, INDENT_12);
                        break;
                }
            } else {
                code += INDENT_8 + "try (AbstractClient client = AbstractClient.newSingletonReturnTcpClient(remote, " + connectTimeoutLiteral + ")) {" + L_S +
                        methodCallCode(method, INDENT_12);
            }
            code += INDENT_8 + "} catch (Exception e) {" + L_S;
            for (Class<?> e : exceptions)
                code += INDENT_12 + "if (e instanceof " + e.getName() + ") throw (" + e.getName() + ") e;" + L_S;
            code += INDENT_12 + "throw new RuntimeException(e);" + L_S;
            if (extendsServiceClient && ADD_STATS.test(method)) code += INDENT_8 + "} finally {" + L_S +
                                                                        INDENT_12 + "Appconn.getAppconn().addStat(" + METHOD_KEY.apply(method) + ", 1, System.nanoTime() - nanos);" + L_S;
            code += INDENT_8 + "}" + L_S;
        } else code += INDENT_8 + "throw new UnsupportedOperationException();" + L_S;
        return code + INDENT_4 + "}" + L_S + L_S;
    }

    Function<Class<?>, String> CONNECT_TIMEOUT_LITERAL = t -> {
        AppconnService annotation = APPCONN_SERVICE_ANNOTATION.apply(t);
        return annotation.connectTimeout() > 0 ? String.valueOf(annotation.unit().toMillis(annotation.connectTimeout())) : "0";
    };

    static String clientClassName(Class<?> service, boolean extendsServiceClient, Client.CONNS_TYPE connsType, boolean simple) {
        String clientClassName = simple ? service.getSimpleName() : service.getName();
        if (extendsServiceClient) {
            switch (connsType) {
                case CONN:
                    clientClassName += "Conn";
                    break;
                case CONNLESS:
                    clientClassName += "Connless";
                    break;
            }
        }
        return clientClassName + "Client";
    }

    static String clientCode(Class<?> service, Collection<Class<?>> appconnTypes, boolean extendsServiceClient, Client.CONNS_TYPE connsType) throws CoderException {
        String clientClassName = clientClassName(service, extendsServiceClient, connsType, true);
        String connectTimeoutLiteral = CONNECT_TIMEOUT_LITERAL.apply(service);
        StringBuilder code = new StringBuilder("package " + service.getPackage().getName() + ";" + L_S + L_S +
                                               (extendsServiceClient && Stream.of(service.getMethods()).anyMatch(ADD_STATS) ? "import org.appconn.Appconn;" + L_S : "") +
                                               (extendsServiceClient ? "import org.appconn.ConnGetter;" + L_S + "import org.appconn.ServiceClient;" + L_S : "") +
                                               "import org.appconn.channel.*;" + L_S + L_S +
                                               (!extendsServiceClient ? "import java.net.SocketAddress;" + L_S + L_S : "") +
                                               CLASS_COMMENT +
                                               "public class " + clientClassName + " " +
                                               (extendsServiceClient ? "extends ServiceClient " : "") +
                                               "implements " + service.getSimpleName() + " {" + L_S + L_S +
                                               (extendsServiceClient ? INDENT_4 + "public " + clientClassName + "(ConnGetter connGetter) {" + L_S +
                                                                       INDENT_8 + "super((byte) " + connsType.byteValue() + ", connGetter, " + connectTimeoutLiteral + ");" + L_S +
                                                                       INDENT_4 + "}" + L_S + L_S :
                                                INDENT_4 + "private final SocketAddress remote;" + L_S + L_S +
                                                INDENT_4 + "public " + clientClassName + "(SocketAddress remote) {" + L_S +
                                                INDENT_8 + "this.remote = remote;" + L_S +
                                                INDENT_4 + "}" + L_S + L_S));
        code.append(typesCode(appconnTypes));
        for (Method m : service.getMethods())
            code.append(methodCode(m, extendsServiceClient, connsType, connectTimeoutLiteral));
        return code.append("}").append(L_S).toString();
    }
}
